/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.RegistryRecord;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Registry extends TableImpl<RegistryRecord> {

	private static final long serialVersionUID = 1898046789;

	/**
	 * The reference instance of <code>public.registry</code>
	 */
	public static final Registry REGISTRY = new Registry();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<RegistryRecord> getRecordType() {
		return RegistryRecord.class;
	}

	/**
	 * The column <code>public.registry.id</code>.
	 */
	public final TableField<RegistryRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.registry.path</code>.
	 */
	public final TableField<RegistryRecord, String> PATH = createField("path", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.registry.value</code>.
	 */
	public final TableField<RegistryRecord, String> VALUE = createField("value", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.registry.updating_time</code>.
	 */
	public final TableField<RegistryRecord, Date> UPDATING_TIME = createField("updating_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * Create a <code>public.registry</code> table reference
	 */
	public Registry() {
		this("registry", null);
	}

	/**
	 * Create an aliased <code>public.registry</code> table reference
	 */
	public Registry(String alias) {
		this(alias, REGISTRY);
	}

	private Registry(String alias, Table<RegistryRecord> aliased) {
		this(alias, aliased, null);
	}

	private Registry(String alias, Table<RegistryRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<RegistryRecord, Long> getIdentity() {
		return Keys.IDENTITY_REGISTRY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<RegistryRecord> getPrimaryKey() {
		return Keys.REGISTRY_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<RegistryRecord>> getKeys() {
		return Arrays.<UniqueKey<RegistryRecord>>asList(Keys.REGISTRY_PKEY, Keys.REGISTRY_PATH_KEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Registry as(String alias) {
		return new Registry(alias, this);
	}

	/**
	 * Rename this table
	 */
	public Registry rename(String name) {
		return new Registry(name, null);
	}
}
